public class Complex extends Object {
	// public member variables
	public float[] fValue;

	// public member methods
	public Complex(String str)
	 {
	 int first = str.indexOf('(');
	 int next = str.indexOf(',');
	 int second = str.indexOf(')');
	 fValue = new float[2];
	 fValue[0] = (new Float(str.substring(first+1,next))).floatValue();
	 fValue[1] = (new Float(str.substring(next+1,second))).floatValue();
	 }


	public Complex(float left,float right)
	 {
	 fValue = new float[2];
	 fValue[0] = left;
	 fValue[1] = right;
	 }

	public Complex(double left,double right)
	 {
	 fValue = new float[2];
	 fValue[0] = (float)left;
	 fValue[1] = (float)right;
	 }

	 public Complex(Complex obj)
	  {
	  fValue = new float[2];
	  fValue[0] = obj.fValue[0];
	  fValue[1] = obj.fValue[1];
	 }
	 
	public Complex add(Complex obj)
	 {
	 fValue[0] += obj.fValue[0];
	 fValue[1] += obj.fValue[1];
	 return this;
	 }

	public Complex add(float left,float right)
	 {
	 fValue[0] += left;
	 fValue[1] += right;
	 return this;
	 }

	public Complex add(double left,double right)
	 {
	  fValue[0] += (float)left;
	  fValue[1] += (float)right;
	  return this;
	 }

	public Complex minus(Complex obj)
	 {
	 fValue[0] -= obj.fValue[0];
	 fValue[1] -= obj.fValue[1];
	 return this;
	 }

	public Complex minus(float left,float right)
	 {
	 fValue[0] -= left;
	 fValue[1] -= right;
	 return this;
	 }

	public Complex minus(double left,double right)
	 {
	  fValue[0] -= (float)left;
	  fValue[1] -= (float)right;
	  return this;
	 }

	public Complex mult(Complex obj)
	 {
	 float fTemp = fValue[0];

	 fValue[0] = fValue[0] * obj.fValue[0] - fValue[1] * obj.fValue[1];
	 fValue[1] = fTemp * obj.fValue[1] + fValue[1] * obj.fValue[0];
	 return this;
	}

	public Complex mult(float left,float right)
	 {
	 float fTemp = fValue[0];

	 fValue[0] = fValue[0] * left - fValue[1] * right;
	 fValue[1] = fTemp * right + fValue[1] * left;
	 return this;
	}
	
	public Complex mult(double left,double right)
	 {
	 float fTemp = fValue[0];
	 fValue[0] = fValue[0] * (float)left - fValue[1] * (float)right;
	 fValue[1] = fTemp * (float)right + fValue[1] * (float)left;
	 return this;
	 }

	public Complex div(Complex obj)
	 {
	 float temp = fValue[0];
	 fValue[0] = (fValue[0] * obj.fValue[0] + fValue[1] * obj.fValue[1])/(obj.fValue[0]*obj.fValue[0] + obj.fValue[1] * obj.fValue[1]);
	 fValue[1] = (fValue[1] * obj.fValue[0] - temp * obj.fValue[1]) / (obj.fValue[0] * obj.fValue[0] + obj.fValue[1] * obj.fValue[1]);
	 return this;
	 }
	public Complex div(float left,float right)
	 {
	 float temp = fValue[0];
	 fValue[0] = (fValue[0] * left + fValue[1] * right) / (left*left + right * right);
	 fValue[1] = (fValue[1] * left - temp * right) / (left * left + right * right);
	 return this;
	 }

	public Complex div(double left,double right)
	 {
	  float fTemp = fValue[0];
	  fValue[0] = (fValue[0] * (float)left + fValue[1] * (float)right) /(float)(left*left+right*right);
	  fValue[1] = (fValue[1] * (float)left - fTemp * (float)right) /(float)(left*left + right*right);
	 return this;
	 }
 
        public String toString()
	 {
	  StringBuffer buf = new StringBuffer();
	  buf.append('(');
	  buf.append(fValue[0]);
	  buf.append(',');
	  buf.append(fValue[1]);
	  buf.append(')');
	  return buf.toString();
	 }
}
	
